/**********************
* WARNING
* Running this code sample will cost you Browshot credits
***********************/

const browshot = require('browshot');
const fs = require("fs");

var client = new browshot('my_api_key');


// Create a text file with a list of URLs
fs.writeFile("batch.txt", "google.com\nmobilito.net\n", (err) => {
	if (err) {
		error(err);
	}
	else {
		submitBatch("batch.txt");
	}
});


function submitBatch(file) {
	client.batchCreate(
		file, 65, { screen_width: 1600, screen_height: 1200, size: 'page', width: 600 }, 
		function(batch) {
			fs.unlink(file, function() {});
			
			if (batch.status == 'error') {
				console.log("Batch failed: " + batch.error);
			}
			else {
				console.log(`Batch #${batch.id} in process`);
				
				// Check the status of the batch every 30 seconds
				timeout = setInterval(checkBatch , 1000 * 30, batch.id);
			}
		}
	);
}

function checkBatch(id) {
	client.batchInfo(id, { }, function(batch) {
		if (batch.status == 'error') {
			clearInterval(timeout);
			
			console.log("Batch failed: " + batch.error);
		}
		else if (batch.status == 'finished') {
			clearInterval(timeout);
			
			// Check how many screenshot failed
			console.log(`${batch.failed}/${batch.count} screenshots failed`);
			
			// The batch succeeded, download the archive. There may be more than 1 URL
			for(var i in batch.urls) {
				console.log(`Downloading ${batch.urls[i]}  ...`);
			}
			
			if (batch.urls.length > 1) {
				// Run 7a if the archive was split into multiple files
				console.log("7a ...");
			}
		}
		else {
			console.log(`Waiting for batch ${batch.id} to finish`);
		}
	});
}
